<template>
    <div class="vue--picture-upload--component vue-component-wrapper">
        <div class="cl-input-file" :class="{'file-single': !multiple, 'file-multiple': multiple}">

            <ul class="row list-unstyled">

                <li v-for="(key, file) in files" :key=key :class="{'cl-has-warning': file.isFailed(), 'cl-success': file.isSaved()}">

                    <a v-if="file.isFailed() || file.isSaved()"    @click="removeFile(file)" class="file-remove">
                        <i class="fa fa-times" aria-hidden="true"></i>
                    </a>
                    <img v-if="file.isSaved()" :src="file.picture.attributes.url" class="img-fluid">
                    <p v-else>
                        <i v-if="file.isValidating() || file.isSaving() || file.isLoading()" class="file-processing" aria-hidden="true"></i>
                        <i v-if="file.isFailed()" class="fa fa-exclamation-circle" aria-hidden="true"></i>
                        <span v-if="!file.isLoading()">{{ file.file.name }}</span>
                        <br>

                        <span v-if="file.isValidating()" class="file-status">Validating ...</span>
                        <span v-if="file.isSaving()" class="file-status">Saving ...</span>
                        <span v-if="file.isLoading()" class="file-status">Loading ...</span>
                        <span v-if="file.isFailed()" class="file-status">{{ file.error.detail }}</span>
                    </p>

                </li>

                <li v-if="allowSelectFiles" class="file-select col-12">
                    <input type="file" :multiple="multiple" @change="filesChange($event.target.files)">
                    <p>
                        <i v-if="files.length === 0" class="fa" :class="faIcon" aria-hidden="true"></i>
                        <span v-if="files.length === 0" v-text="helpText"></span>
                        <a v-if="showButtonBrowse" class="btn blue">Browse files</a>
                    </p>
                </li>

            </ul>

        </div>
    </div>
</template>

<script>
const STATUS_LOADING = 0,
  STATUS_VALIDATING = 1,
  STATUS_SAVING = 2,
  STATUS_SAVED = 3,
  STATUS_FAILED = 4;

export default {
  name: "picture-upload",

  props: {
    validateHere: {
      type: String,
      required: true
    },
    uploadHere: {
      type: String,
      default: "/api/v2.0/picture"
    },
    fieldName: {
      type: String,
      required: true
    },
    source: {
      type: String,
      required: true
    },
    storage: {
      type: String,
      default: "tmp"
    },
    multiple: {
      type: Boolean,
      default: false
    },
    state: {
      type: Array,
      default: () => {
        return [];
      }
    },
    faIcon: {
      type: String,
      default: "fa-picture-o"
    },
    showButtonBrowse: {
      type: Boolean,
      default: false
    },
    maxFiles: {
      type: Number,
      default: -1
    },
    helpText: {
      type: String
    }
  },

  data() {
    return {
      uploadedFiles: [],
      uploadErrors: [],
      currentStatus: null,
      files: [],
      forceUpdate: false
    };
  },

  computed: {
    allowSelectFiles() {
      if (this.multiple && this.files.length < this.maxFiles) {
        return true;
      }

      return this.files.length === 0;
    },
    directory() {
      return _.kebabCase(this.source) + "/" + _.kebabCase(this.fieldName) + "/";
    }
  },

  methods: {
    reset() {
      this.uploadedFiles = [];
      this.uploadErrors = [];
      this.currentStatus = null;
      this.files = [];
      this.forceUpdate = false;
    },

    uploadToTmp() {
      let self = this;

      this.files.forEach(file => {
        if (file.isSaving()) {
          let formData = self.makeData("picture", "picture", file);
          axios
            .post(self.uploadHere, formData)
            .then(r => {
              file.setPicture(r.data.data);
              self.$emit("pu:uploaded-picture", r.data.data);
            })
            .catch(e => {
              file.setUploadError({
                detail: e.response.data.message
              });
            });
        }
      });
    },

    loadFileData(fileId) {
      let self = this,
        file = new UFile(this, {}, STATUS_LOADING, fileId);

      self.files.push(file);

      return axios
        .get(this.uploadHere + "/" + fileId)
        .then(r => {
          file.setPicture(r.data.data);
          self.$emit("pu:uploaded-picture", r.data.data);
        })
        .catch(e => {
          file.setUploadError({
            detail: e.response.data.message
          });
        });
    },

    filesChange(fileList) {
      if (!fileList.length) return;

      let self = this;

      Array.from(Array(fileList.length).keys()).map(x => {
        self.files.push(new UFile(self, fileList[x], STATUS_VALIDATING));
      });

      this.validate();
    },

    validate() {
      let self = this,
        formData = this.makeData(this.source, this.fieldName, this.files);

      axios
        .post(this.validateHere, formData)
        .then(r => {
          self.processValidationErrors();
          self.uploadToTmp();
        })
        .catch(e => {
          self.uploadErrors = e.response.data.errors;
          self.processValidationErrors();
          self.uploadToTmp();
        });
    },

    makeData(source, field, files) {
      // handle file changes
      const formData = new FormData();
      formData.append("data[type]", source);
      formData.append("data[attributes][directory]", this.directory);
      formData.append("data[attributes][storage]", this.storage);

      let self = this;

      if (files instanceof UFile) {
        // If need send only one file, like from save to tmp.
        formData.append(
          "data[attributes][" + field + "]",
          files.file,
          files.file.name
        );
      } else {
        files.forEach(e => {
          let attribute = "data[attributes][" + field + "]";
          if (self.multiple) attribute += "[" + e.id + "]";
          formData.append(attribute, e.file, e.file.name);
        });
      }

      return formData;
    },

    removeFile(file) {
      this.files = this.files.filter(e => {
        return e.id !== file.id;
      });

      if (file.isSaved()) this.$emit("pu:removed-picture", file.picture);
    },

    removeError(error) {
      if (error === undefined) return false;

      this.uploadErrors = this.uploadErrors.filter(e => {
        return e.source.pointer != error.source.pointer;
      });
    },

    processValidationErrors() {
      let self = this;

      this.files.forEach(e => {
        let error = this.getErrorByPointer(e.pointer);

        if (error !== undefined) {
          e.setValidationError(error);
          self.removeError(error);
        } else {
          if (e.isValidating()) e.status = STATUS_SAVING;
        }
      });
    },

    getErrorByPointer(pointer) {
      return this.uploadErrors.find(e => {
        return e.source.pointer == pointer;
      });
    },

    setDefaultState() {
      if (this.state.length == 0) return false;

      for (let i = 0; i < this.state.length; i++) {
        this.loadFileData(this.state[i]);
      }
      this.forceUpdate = false;
    }
  },

  beforeUpdate() {
    if (this.forceUpdate) {
      this.reset();
      this.setDefaultState();
    }
  },

  created() {
    this.setDefaultState();
  }
};

class UFile {
  constructor(vue, file, status, id) {
    this.file = file;
    this.setStatus(status);

    this.id = id === undefined ? Math.floor(Math.random() * 1000 + 1) : id;

    this.pointer = "/data/attributes/" + vue.fieldName;
    if (vue.multiple) this.pointer += "/" + this.id;

    this.error = null;
    this.picture = null;
  }

  setValidationError(error) {
    this.error = error;
    this.setStatus(STATUS_FAILED);
  }

  setUploadError(error) {
    this.error = error;
    this.setStatus(STATUS_FAILED);
  }

  setPicture(picture) {
    this.picture = picture;
    this.setStatus(STATUS_SAVED);
  }

  setStatus(status) {
    this.status = status;
  }

  isLoading() {
    return this.status === STATUS_LOADING;
  }

  isValidating() {
    return this.status === STATUS_VALIDATING;
  }

  isSaving() {
    return this.status === STATUS_SAVING;
  }

  isSaved() {
    return this.status === STATUS_SAVED;
  }

  isFailed() {
    return this.status === STATUS_FAILED;
  }
}
</script>
